package constants

import . "github.com/xeronith/diamante/contracts/localization"

var Errors = Resource{}

func init() {
	// Default Error Messages
	Errors[ERROR_MESSAGE_INITIALIZE] = "initialize"
	Errors[ERROR_MESSAGE_NOT_IMPLEMENTED] = "not_implemented"
	Errors[ERROR_MESSAGE_OPERATION_FAILED] = "operation_failed"
	Errors[ERROR_MESSAGE_OPERATION_NOT_SUPPORTED] = "operation_not_supported"
	Errors[ERROR_MESSAGE_OPERATION_RUNNER_NOT_AVAILABLE] = "operation_runner_not_available"
	Errors[ERROR_MESSAGE_OPERATION_PAYLOAD_NOT_SUPPORTED] = "operation_payload_not_supported"
	Errors[ERROR_MESSAGE_UNRESOLVED_DEPENDENCIES] = "unresolved_dependencies"
	Errors[ERROR_MESSAGE_SYSTEM_COMPONENT_NOT_FOUND] = "system_component_not_found"
	Errors[ERROR_MESSAGE_DOCUMENT_NOT_FOUND] = "document_not_found"
	Errors[ERROR_MESSAGE_SYSTEM_SCHEDULE_NOT_FOUND] = "system_schedule_not_found"
	Errors[ERROR_MESSAGE_IDENTITY_NOT_FOUND] = "identity_not_found"
	Errors[ERROR_MESSAGE_ACCESS_CONTROL_NOT_FOUND] = "access_control_not_found"
	Errors[ERROR_MESSAGE_REMOTE_ACTIVITY_NOT_FOUND] = "remote_activity_not_found"
	Errors[ERROR_MESSAGE_CATEGORY_TYPE_NOT_FOUND] = "category_type_not_found"
	Errors[ERROR_MESSAGE_CATEGORY_NOT_FOUND] = "category_not_found"
	Errors[ERROR_MESSAGE_USER_NOT_FOUND] = "user_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_OBJECT_NOT_FOUND] = "activity_pub_object_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_ACTIVITY_NOT_FOUND] = "activity_pub_activity_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_PUBLIC_KEY_NOT_FOUND] = "activity_pub_public_key_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_LINK_NOT_FOUND] = "activity_pub_link_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_MEDIA_NOT_FOUND] = "activity_pub_media_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_INCOMING_ACTIVITY_NOT_FOUND] = "activity_pub_incoming_activity_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_OUTGOING_ACTIVITY_NOT_FOUND] = "activity_pub_outgoing_activity_not_found"
	Errors[ERROR_MESSAGE_ACTIVITY_PUB_FOLLOWER_NOT_FOUND] = "activity_pub_follower_not_found"
	Errors[ERROR_MESSAGE_SPI_NOT_FOUND] = "spi_not_found"
	Errors[ERROR_MESSAGE_UNKNOWN_DOCUMENT] = "unknown_document"
	Errors[ERROR_MESSAGE_UNKNOWN_SYSTEM_SCHEDULE] = "unknown_system_schedule"
	Errors[ERROR_MESSAGE_UNKNOWN_IDENTITY] = "unknown_identity"
	Errors[ERROR_MESSAGE_UNKNOWN_ACCESS_CONTROL] = "unknown_access_control"
	Errors[ERROR_MESSAGE_UNKNOWN_REMOTE_ACTIVITY] = "unknown_remote_activity"
	Errors[ERROR_MESSAGE_UNKNOWN_CATEGORY_TYPE] = "unknown_category_type"
	Errors[ERROR_MESSAGE_UNKNOWN_CATEGORY] = "unknown_category"
	Errors[ERROR_MESSAGE_UNKNOWN_USER] = "unknown_user"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_OBJECT] = "unknown_activity_pub_object"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_ACTIVITY] = "unknown_activity_pub_activity"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_PUBLIC_KEY] = "unknown_activity_pub_public_key"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_LINK] = "unknown_activity_pub_link"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_MEDIA] = "unknown_activity_pub_media"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_INCOMING_ACTIVITY] = "unknown_activity_pub_incoming_activity"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_OUTGOING_ACTIVITY] = "unknown_activity_pub_outgoing_activity"
	Errors[ERROR_MESSAGE_UNKNOWN_ACTIVITY_PUB_FOLLOWER] = "unknown_activity_pub_follower"
	Errors[ERROR_MESSAGE_UNKNOWN_SPI] = "unknown_spi"
	Errors[ERROR_MESSAGE_INVALID_ID] = "invalid_id"
	Errors[ERROR_MESSAGE_INVALID_PARAMETERS] = "invalid_parameters"
	Errors[ERROR_MESSAGE_INVALID_USERNAME_FOR_CHECK_USERNAME_AVAILABILITY] = "invalid_username"
	Errors[ERROR_MESSAGE_INVALID_USERNAME_FOR_SIGNUP] = "invalid_username"
	Errors[ERROR_MESSAGE_INVALID_EMAIL_FOR_SIGNUP] = "invalid_email"
	Errors[ERROR_MESSAGE_INVALID_PASSWORD_FOR_SIGNUP] = "invalid_password"
	Errors[ERROR_MESSAGE_INVALID_EMAIL_FOR_RESEND_VERIFICATION_CODE] = "invalid_email"
	Errors[ERROR_MESSAGE_INVALID_EMAIL_FOR_VERIFY] = "invalid_email"
	Errors[ERROR_MESSAGE_INVALID_EMAIL_FOR_LOGIN] = "invalid_email"
	Errors[ERROR_MESSAGE_INVALID_PASSWORD_FOR_LOGIN] = "invalid_password"
	Errors[ERROR_MESSAGE_INVALID_CURRENT_PASSWORD_FOR_CHANGE_PASSWORD] = "invalid_current_password"
	Errors[ERROR_MESSAGE_INVALID_NEW_PASSWORD_FOR_CHANGE_PASSWORD] = "invalid_new_password"
	Errors[ERROR_MESSAGE_INVALID_RESOURCE_FOR_WEBFINGER] = "invalid_resource"
	Errors[ERROR_MESSAGE_DATA_INTEGRITY_VIOLATION] = "data_integrity_violation"
	Errors[ERROR_MESSAGE_INVALID_STATE] = "invalid_state"
	Errors[ERROR_MESSAGE_USER_NOT_REGISTERED] = "user_not_registered"
	Errors[ERROR_MESSAGE_USERNAME_OR_EMAIL_ALREADY_REGISTERED] = "username_or_email_already_registered"
	Errors[ERROR_MESSAGE_ACCOUNT_NOT_VERIFIED] = "account_not_verified"
	Errors[ERROR_MESSAGE_ACCOUNT_BLOCKED] = "account_blocked"
	Errors[ERROR_MESSAGE_INVALID_TOKEN] = "invalid_token"
	Errors[ERROR_MESSAGE_INVALID_CONFIRMATION_CODE] = "invalid_confirmation_code"
	Errors[ERROR_MESSAGE_PERMISSION_DENIED] = "permission_denied"
	Errors[ERROR_MESSAGE_INVALID_PERSON_KIND] = "invalid_person_kind"
	Errors[ERROR_MESSAGE_INVALID_CREDENTIALS] = "invalid_credentials"
	// Overrides
	Errors[ERROR_MESSAGE_DATA_INTEGRITY_VIOLATION] = "data_integrity_violation"
	Errors[ERROR_MESSAGE_INVALID_PASSWORD_FOR_SIGNUP] = "Your password should be at least 7 characters long including uppercase and lowercase letters, numbers and special characters."
	Errors[ERROR_MESSAGE_INVALID_PASSWORD_FOR_LOGIN] = "Your password should be at least 7 characters long including uppercase and lowercase letters, numbers and special characters."
}
